/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

// #include <new.h>
#include "Rogus.h"
#include "OMS_app.h"
#include "text_win.h"
#include "err_and_warn.h"
#include "sched.h"
#include "Rogus_McBogus.h"

#ifdef NDEBUG
#define APPEND_TO_VERSION ""
#else
#define APPEND_TO_VERSION " DEBUG"
#endif

//--------------------------------------------------------------------------------------------------
// some global variables
OMS_app* oap;
scheduler* schedp;
const char* rogus_version = "1.7a" APPEND_TO_VERSION;

//--------------------------------------------------------------------------------------------------

class basic_app
{
private:
	static void my_new_handler() { ew.e( "new failed: out of memory" ); }
public:
	basic_app(void (*func)(const char*, int))
	{
		tw.init(func);
//		set_new_handler( my_new_handler );
	}
};

//--------------------------------------------------------------------------------------------------

class CPEditApp : public basic_app
{
public:
	 CPEditApp(void (*func)(const char*, int));
	~CPEditApp();
	void StartUp();
	
private:
	OMS_app oa;
	scheduler sched;	
};


//--------------------------------------------------------------------------------------------------

CPEditApp::
CPEditApp(void (*func)(const char*, int)) : oa( 'RMcB' ), basic_app(func) { oap = &oa; schedp = &sched; }

 CPEditApp::
~CPEditApp() 
{
}

void
CPEditApp::
StartUp()
{			
	tw.pr("This is Rogus McBogus version %s for Windows.\n",rogus_version);
}

//--------------------------------------------------------------------------------------------------

static Bool rogus_exists = False;

Rogus_McBogus::
Rogus_McBogus(void (*func)(const char*, int)) 
{
	if (rogus_exists == True)
	{
		ew.a("You can't make more than one Rogus at a time!");
		cp = NULL;
	}
	else
	{
		cp = new CPEditApp(func);
		cp->StartUp();
	}
	rogus_exists = True;
}

Rogus_McBogus::
~Rogus_McBogus()
{
	setParser((parser*)NULL, "");
	if (cp != NULL)
		delete cp;
	cp = NULL;
	rogus_exists = False;
}

void
Rogus_McBogus::
setParser(parserPtr pp, const char* name)
{
	if (p != NULL)
		Statistic::report();
	oap->lp = NULL;
	p = pp;
	oap->lp = pp;
	if (pp != NULL)
	{
		Statistic::reset(name);
		tw.pr("%s now active.\n",name);
	}
}

// Authors: Ben Denckla, Patrick Pelletier
