/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

#ifndef UTILSTRING_H
#define UTILSTRING_H

#include <string.h>
#include "basic_types.h"
#include "UtilPtr.h"

class UtilString
{
	char* p;
public:
	const int length;
	UtilString() : length(0) { p = new char[1]; p[0] = 0; }
	UtilString(const char* s) : length(strlen(s)) { p = new char[length+1]; strcpy(p, s); }
	~UtilString() { delete[] p; }
	Bool operator==(const UtilString& x) const { return ((length == x.length) && (strcmp(p, x.p) == 0)); }
	Bool operator==(const char* x) const { return (strcmp(p, x) == 0); }
	char operator[](int i) const { return (((i >= 0) && (i < length)) ? p[i] : 0); }
	operator const char*() const { return p; }
};

typedef UtilPtr<UtilString> UtilStringPtr;

#endif
// Author: Patrick Pelletier
