/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

// This parser, unlike a normal Rogus parser, doesn't actually do any
// MIDI I/O. It simply lists the input and output nodes present in the
// system. May be useful for diagnostics, or if you're curious.

#include "WhatNodesParser.h"
#include "data_structs.h"
#include "ParserRegistration.h"

WhatNodesParser::
WhatNodesParser()
{
	int i;
	tw.pr("\nOutput Nodes:\n");
	for (i = 0; i < oap->howManyOutputNodes(); i++)
		tw.pr("  %s\n",oap->getOutputNodeName(i));

	tw.pr("\nInput Nodes:\n");
	for (i = 0; i < oap->howManyInputNodes(); i++)
		tw.pr("  %s\n",oap->getInputNodeName(i));

	tw.pr("\n");
}

static parser* newFunc()
{
	return (new WhatNodesParser());
}

static ParserRegistration reg(newFunc, "WhatNodesParser");

// Author: Patrick Pelletier
