/*
** Copyright 1995-1996 by the Massachusetts Institute of Technology.  All
** rights reserved. For more information, see the file COPYING which came
** with this source distribution.
*/

 /* This file gives example of how to create a parser with hooks into your own MIDI input 
processing functions.  In this case, a delayed octave generator is made. */

#include "octave_parser2.h"
#include "data_structs.h"
#include "ParserRegistration.h"

static int ou_node;

static
void
note_on( MIDI_msg *m ) 
{
	if (m->d2)
	{
		m->node = ou_node;
		//oap->write(m);
		
		m->d1 += 12; // assumes no input has key > 127-12==115
		
		task_data td( *m, 1000, m->time );
		int e = schedp->insert( td );
		if (e) ew.w( "insert failed in octave parser" );
	}
	
}

octave_parser2::
octave_parser2()
{
	ou_node = oap->open_output();
	oap->open_input();

	msg_hnd[MIDI_msg::note_on] = note_on;
		
	MIDI_msg m;
	m.set( MIDI_msg::program_chn, 0 /* chan */, 20, 0 /* not used */, ou_node );
	oap->write(&m);
}

static parser* newFunc()
{
	return (new octave_parser2());
}

static ParserRegistration reg(newFunc, "octave_parser2");

// Author: Ben Denckla
