(defun fixbool-do-one (thisfile)
  (find-file thisfile)
  (let ((old-case-fold-search case-fold-search)) ; save old value
    (setq case-fold-search nil)		; make search case-sensitive
    (goto-char (point-min))		; go to beginning of buffer
    (while (word-search-forward "bool" nil t)
      (replace-match "Bool" t t))
    (goto-char (point-min))		; go to beginning of buffer
    (while (word-search-forward "true" nil t)
      (replace-match "True" t t))
    (goto-char (point-min))		; go to beginning of buffer
    (while (word-search-forward "false" nil t)
      (replace-match "False" t t))
    (setq case-fold-search old-case-fold-search)) ; restore old value
  (save-buffer))

(defun fixbool-helper (dir-contents)
  (if (null dir-contents)
      nil				; base case
    (let ((thisfile (car dir-contents)))
      (cond ((file-directory-p thisfile)
	     (fixbool thisfile))	; recurse through directories
	    ((string-match "\\.cpp$" thisfile)
	     (fixbool-do-one thisfile))
	    ((string-match "\\.h$" thisfile)
	     (fixbool-do-one thisfile))))
    (fixbool-helper (cdr dir-contents))))

(defun fixbool (start-dir)
  "Upgrades a Rogus McBogus directory tree."
  (interactive "DDirectory of project to upgrade: ")
  (if (not (or (string-match "\\\\\\." start-dir)
	       (string-match "/\\." start-dir))) ; important!
      (fixbool-helper (directory-files start-dir t))))

;; Author: Patrick Pelletier
